package while_;

import java.util.Set;

public abstract class BinAexp implements Aexp{

	protected BinAexp(Aexp aexp1, Aexp aexp2) {
		this.aexp1 = aexp1;
		this.aexp2 = aexp2;
	}

	protected Aexp aexp1;
	protected Aexp aexp2;
	protected abstract int op(int i1, int i2);
	protected abstract Aexp build(Aexp a1, Aexp a2);
	public int value(State state) {
		return op(aexp1.value(state),aexp2.value(state));
	}

	public Aexp apply(Substitution substitution) {
		return build(aexp1.apply(substitution), aexp2.apply(substitution));
	}

	public Set<String> free(Set<String> set) {
		aexp1.free(set);
		aexp2.free(set);
		return set;
	}

}