package while_;

import java.util.Set;

public abstract class BinRel implements Bexp {

	protected BinRel(Aexp aexp1, Aexp aexp2) {
		this.aexp1 = aexp1;
		this.aexp2 = aexp2;
	}
	protected Aexp aexp1;
	protected Aexp aexp2;

	public boolean value(State state) {
		return op(aexp1.value(state), aexp2.value(state));
	}
	public Bexp apply(Substitution substitution) {
		return build(aexp1.apply(substitution), aexp2.apply(substitution));
	}
	public Set<String> free(Set<String> set) {
		aexp1.free(set);
		aexp2.free(set);
		return set;
	}

	protected abstract boolean op(int value, int value2);
	protected abstract Bexp build(Aexp a1, Aexp a2);

}