package while_;

import java.util.Set;

public class Variable implements Aexp {
	public Variable(String name) {
		this.name = name;
	}

	private String name;

	public int value(State state) {
		return state.get(name);
	}

	public Aexp apply(Substitution substitution) {

		return substitution.apply(this);
	}

	public Set<String> free(Set<String> set) {
		set.add(name);
		return set;
	}

	public boolean equals(Object obj) {
		if (!(obj instanceof Variable)) {
			return false;
		}
		Variable other = (Variable) obj;
		return name.equals(other.name);
	}

}
